"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RBField = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactBootstrap = require("react-bootstrap");

var _FieldCommon = require("./FieldCommon");

var _Utils = require("./Utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Select;
var CreatableSelect;
var AsyncSelect;
var AsyncCreatableSelect;
var moment;
var Datetime;

try {
  Select = require('react-select').default;
} catch (_) {
  Select = null;
}

try {
  CreatableSelect = require('react-select/creatable').default;
} catch (_) {
  CreatableSelect = null;
}

try {
  AsyncSelect = require('react-select/async').default;
} catch (_) {
  AsyncSelect = null;
}

try {
  AsyncCreatableSelect = require('react-select/async-creatable').default;
} catch (_) {
  AsyncCreatableSelect = null;
}

try {
  moment = require('moment');
} catch (_) {
  moment = null;
}

try {
  Datetime = require('react-datetime').default;
} catch (_) {
  Datetime = null;
}

var didWarnImportReactSelect = false;
var didWarnImportReactDatetime = false;

var getIdInput = (_ref) => {
  var {
    name
  } = _ref;
  return "rbf_".concat(name, "_input");
};

var getIdRadio = (name, index) => "rbf_".concat(name, "_").concat(index);

var getIdHelp = (_ref2) => {
  var {
    name
  } = _ref2;
  return "rbf_".concat(name, "_help");
};

var getNumber = value => value === '' ? '' : +value;

var RBField = props => {
  var {
    type = 'input',
    name,
    as,
    hidden,
    isValid,
    isInvalid,
    help
  } = props;

  if (type === 'hidden') {
    return null;
  }

  var propsGroup = {
    controlId: name,
    as,
    hidden
  };
  var propsControl = {
    type,
    isValid,
    isInvalid
  }; // Removed name.

  var SectionHelp;

  if (help) {
    var idHelp = getIdHelp(props);
    SectionHelp = getSectionHelp(idHelp, help);
    propsControl['aria-describedby'] = idHelp;
  }

  var {
    Content,
    Label,
    shouldReturnNow
  } = getSectionControl(propsGroup, propsControl, props, SectionHelp, getSectionFeedback(props));

  if (!Content) {
    return null;
  }

  if (shouldReturnNow) {
    return Content;
  }

  return (0, _FieldCommon.getLayout)(propsGroup, Label, Content, props);
};

exports.RBField = RBField;

var getSectionHelp = (id, help) => {
  return /*#__PURE__*/_react.default.createElement(_reactBootstrap.Form.Text, {
    id: id,
    muted: true
  }, help);
};

var getSectionFeedback = (_ref3) => {
  var {
    error
  } = _ref3;
  return /*#__PURE__*/_react.default.createElement(_reactBootstrap.Form.Control.Feedback, {
    type: "invalid"
  }, error);
};

var getSectionControl = (propsGroup, propsControl, _ref4, SectionHelp, SectionFeedback) => {
  var {
    type
  } = _ref4,
      props = _objectWithoutProperties(_ref4, ["type"]);

  if (type === 'radio') {
    var {
      name: _name,
      value: _value,
      size: _size,
      label: _label,
      hiddenLabel: _hiddenLabel,
      disabled: _disabled,
      options,
      inline,
      isValid,
      isInvalid,
      onChange: _onChange,
      handleChange: _handleChange
    } = props;
    var propsLabelRadio = {
      className: (0, _FieldCommon.getSizeClass)(_size)
    };
    var Radios;

    if (options) {
      Radios = options.map((_ref5, index) => {
        var {
          value: valueItem,
          label: labelItem
        } = _ref5;
        var propsRadio = {
          name: _name,
          type,
          checked: valueItem === _value,
          onChange: () => {
            if (_onChange) {
              _onChange(valueItem);
            }

            _handleChange(_name, valueItem);
          },
          isValid,
          isInvalid,
          disabled: _disabled
        };
        var LabelRadio = (0, _FieldCommon.createLabel)(_reactBootstrap.Form.Check.Label, propsLabelRadio, props, labelItem);
        return /*#__PURE__*/_react.default.createElement(_reactBootstrap.Form.Check, {
          key: index,
          type: type,
          id: getIdRadio(_name, index),
          inline: inline
        }, /*#__PURE__*/_react.default.createElement(_reactBootstrap.Form.Check.Input, propsRadio), LabelRadio);
      });
      propsGroup.role = 'radiogroup';
    }

    var _Label;

    if (!_hiddenLabel) {
      var propsLabel = _objectSpread(_objectSpread({}, props), {}, {
        className: 'rbf-group'
      });

      _Label = (0, _FieldCommon.getSectionLabel)(propsLabel);
      propsGroup['aria-labelledby'] = (0, _FieldCommon.getIdLabel)(_name);
    } else {
      propsGroup['aria-label'] = _label;
    }

    var _Content = /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, Radios, createControlHidden(isValid, isInvalid), SectionHelp, SectionFeedback);

    return {
      Content: _Content,
      Label: _Label
    };
  }

  if (type === 'checkbox' || type === 'switch') {
    var {
      name: _name2,
      value: _value2,
      size: _size2,
      label: _label2,
      hiddenLabel: _hiddenLabel2,
      disabled: _disabled2,
      inline: _inline,
      single,
      as,
      onChange: _onChange2,
      handleChange: _handleChange2,
      hidden
    } = props;
    var shouldReturnNow = !single && !as;
    var propsCheck = {
      type,
      inline: _inline
    };
    var propsCheckClassNames = [];

    if (shouldReturnNow) {
      propsCheck.id = _name2;

      if (hidden) {
        // Setting the hidden prop regularly doesn't work.
        propsCheckClassNames.push('rbf-hidden');
      }
    }

    var propsCheckLabel = {
      id: (0, _FieldCommon.getIdLabel)(_name2),
      className: (0, _FieldCommon.getSizeClass)(_size2)
    };
    var CheckLabel;

    if (!_hiddenLabel2) {
      CheckLabel = (0, _FieldCommon.createLabel)(_reactBootstrap.Form.Check.Label, propsCheckLabel, props);
    } else {
      if (type == 'switch') {
        CheckLabel = (0, _FieldCommon.createLabel)(_reactBootstrap.Form.Check.Label, propsCheckLabel, props, /*#__PURE__*/_react.default.createElement("span", {
          className: "sr-only"
        }, _label2));
      } else {
        propsControl['aria-label'] = _label2;
      }

      propsCheckClassNames.push((0, _FieldCommon.getSizeClass)(_size2, false));
    }

    if (propsCheckClassNames.length > 0) {
      propsCheck.className = propsCheckClassNames.join(' ');
    }

    propsControl.type = 'checkbox';
    propsControl.disabled = _disabled2;
    propsControl.checked = !!_value2;

    propsControl.onChange = () => {
      var valueNew = !_value2;

      if (_onChange2) {
        _onChange2(valueNew);
      }

      _handleChange2(_name2, valueNew);
    };

    var _Content2 = /*#__PURE__*/_react.default.createElement(_reactBootstrap.Form.Check, _extends({}, propsCheck, {
      hidden: true
    }), /*#__PURE__*/_react.default.createElement(_reactBootstrap.Form.Check.Input, propsControl), CheckLabel, SectionHelp, SectionFeedback);

    return {
      Content: _Content2,
      shouldReturnNow
    };
  }

  if (type === 'datetime') {
    var errorDatetime = [];

    if (!moment) {
      errorDatetime.push('\'moment\'');
    }

    if (!Datetime) {
      errorDatetime.push('\'react-datetime\'');
    }

    if (errorDatetime.length > 0) {
      if (!didWarnImportReactDatetime) {
        console.warn("To use advanced datetime input, please install ".concat(errorDatetime.join(' and ')));
        didWarnImportReactDatetime = true;
      }

      return null;
    }

    var {
      name: _name3,
      value: _value3,
      label: _label3,
      hiddenLabel: _hiddenLabel3,
      placeholder: _placeholder,
      disabled: _disabled3,
      readOnly: _readOnly,
      plaintext: _plaintext,
      size: _size3,
      dateFormat,
      timeFormat,
      locale,
      onChange: _onChange3,
      handleChange: _handleChange3,
      isValid: _isValid,
      isInvalid: _isInvalid
    } = props;
    var datetimeFormat = (0, _Utils.getDatetimeFormat)(dateFormat, timeFormat);
    var _propsControl = {
      dateFormat,
      timeFormat,
      locale,
      initialValue: _value3,
      onChange: value => {
        var valueString = (0, _Utils.getDatetimeString)(value, datetimeFormat, locale);

        if (_onChange3) {
          _onChange3(valueString);
        }

        _handleChange3(_name3, valueString);
      },
      closeOnSelect: true
    };
    var inputProps = {
      placeholder: _placeholder,
      disabled: _disabled3,
      readOnly: _readOnly,
      className: 'form-control'
    };

    var _Label2;

    if (!_hiddenLabel3) {
      _Label2 = (0, _FieldCommon.getSectionLabel)(props);
      inputProps['aria-labelledby'] = (0, _FieldCommon.getIdLabel)(_name3);
    } else {
      inputProps['aria-label'] = _label3;
    }

    if (_readOnly) {
      _propsControl.open = false;
    }

    if (!_value3) {
      // Needed to force reset.
      inputProps.value = '';
    }

    if (_plaintext) {
      inputProps.className += ' form-control-plaintext';
    }

    if (_size3) {
      if (_size3 === 'sm') {
        inputProps.className += ' form-control-sm';
      } else if (_size3 === 'lg') {
        inputProps.className += ' form-control-lg';
      }
    }

    _propsControl.inputProps = inputProps;

    var _Content3 = /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(Datetime, _propsControl), createControlHidden(_isValid, _isInvalid), SectionHelp, SectionFeedback);

    return {
      Content: _Content3,
      Label: _Label2
    };
  }

  if (type === 'select') {
    var {
      options: _options
    } = props;

    if (_options) {
      if (!Select) {
        if (!didWarnImportReactSelect) {
          console.warn('To use advanced select input, please install \'react-select\'');
          didWarnImportReactSelect = true;
        }

        return null;
      }

      var {
        name: _name5,
        value: _value5,
        label: _label5,
        hiddenLabel: _hiddenLabel5,
        placeholder: _placeholder2,
        disabled: _disabled5,
        isSearchable,
        isClearable,
        isMulti,
        isCreatable,
        noOptionsMessage,
        async,
        defaultOptions,
        cacheOptions,
        isValid: _isValid2,
        isInvalid: _isInvalid2,
        onChange: _onChange5,
        handleChange: _handleChange5
      } = props;
      var _propsControl2 = {
        inputId: getIdInput(props),
        placeholder: _placeholder2,
        isDisabled: _disabled5,
        isClearable,
        isSearchable,
        isMulti,
        noOptionsMessage,
        value: _value5 !== null && _value5 !== void 0 ? _value5 : null,
        // Needed to force reset.
        onChange: option => {
          _handleChange5(_name5, option);

          if (_onChange5) {
            _onChange5(option);
          }
        },
        classNamePrefix: _isInvalid2 ? 'react-select-invalid' : _isValid2 ? 'react-select-valid' : 'react-select'
      };

      if (_disabled5) {
        _propsControl2.styles = {
          control: styles => _objectSpread(_objectSpread({}, styles), {}, {
            backgroundColor: '#e9ecef'
          })
        };
      }

      var SelectType;

      if (async) {
        _propsControl2.loadOptions = _options;
        _propsControl2.defaultOptions = defaultOptions;
        _propsControl2.cacheOptions = cacheOptions;
        SelectType = isCreatable ? AsyncCreatableSelect : AsyncSelect;
      } else {
        _propsControl2.options = _options;
        SelectType = isCreatable ? CreatableSelect : Select;
      }

      var _Label4;

      if (!_hiddenLabel5) {
        _Label4 = (0, _FieldCommon.getSectionLabel)(props);
        _propsControl2['aria-labelledby'] = (0, _FieldCommon.getIdLabel)(_name5);
      } else {
        _propsControl2['aria-label'] = _label5;
      }

      var _Content5 = /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(SelectType, _propsControl2), createControlHidden(_isValid2, _isInvalid2), SectionHelp, SectionFeedback);

      return {
        Content: _Content5,
        Label: _Label4
      };
    }

    var {
      name: _name4,
      value: _value4,
      plaintext: _plaintext2,
      size: _size4,
      disabled: _disabled4,
      multiple,
      htmlSize,
      children,
      label: _label4,
      hiddenLabel: _hiddenLabel4,
      onChange: _onChange4,
      handleChange: _handleChange4
    } = props;

    var _Label3;

    if (!_hiddenLabel4) {
      _Label3 = (0, _FieldCommon.getSectionLabel)(props);
    } else {
      propsControl['aria-label'] = _label4;
    }

    propsControl.plaintext = _plaintext2;
    propsControl.disabled = _disabled4;
    propsControl.size = _size4;
    propsControl.as = type;
    propsControl.children = children;
    propsControl.value = _value4;

    if (multiple || htmlSize) {
      propsControl.multiple = true;
      propsControl.htmlSize = htmlSize;

      propsControl.onChange = e => {
        var value = [].slice.call(e.target.selectedOptions).map(option => option.value);

        if (_onChange4) {
          _onChange4(value);
        }

        _handleChange4(_name4, value);
      };
    } else {
      propsControl.onChange = e => {
        var value = e.target.value;

        if (_onChange4) {
          _onChange4(value);
        }

        _handleChange4(_name4, value);
      };
    }

    var _Content4 = /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactBootstrap.Form.Control, propsControl), SectionHelp, SectionFeedback);

    return {
      Content: _Content4,
      Label: _Label3
    };
  }

  if (type === 'file') {
    var {
      name: _name6,
      value: _value6,
      disabled: _disabled6,
      accept,
      multiple: _multiple,
      ['data-browse']: dataBrowse,
      label: _label6,
      hiddenLabel: _hiddenLabel6,
      onChange: _onChange6,
      handleChange: _handleChange6
    } = props;
    propsControl.disabled = _disabled6;

    propsControl.onChange = e => {
      var value = e.target.files;

      if (_onChange6) {
        _onChange6(value);
      }

      _handleChange6(_name6, value);
    };

    propsControl.accept = accept;
    propsControl.multiple = _multiple;
    var SelectedFiles;

    if (_value6) {
      propsControl.files = _value6;
      SelectedFiles = /*#__PURE__*/_react.default.createElement("span", {
        muted: true
      }, Array.from(_value6).map((_ref6) => {
        var {
          name
        } = _ref6;
        return name;
      }).join(', '));
    }

    var _Label5 = (0, _FieldCommon.createLabel)(_reactBootstrap.Form.File.Label, {
      ['data-browse']: dataBrowse
    }, props, !_hiddenLabel6 ? (0, _FieldCommon.createContentLabel)(props) : /*#__PURE__*/_react.default.createElement("span", {
      className: "sr-only"
    }, _label6));

    var _Content6 = /*#__PURE__*/_react.default.createElement(_reactBootstrap.Form.File, {
      custom: true
    }, /*#__PURE__*/_react.default.createElement(_reactBootstrap.Form.File.Input, propsControl), _Label5, SelectedFiles, SectionHelp, SectionFeedback);

    return {
      Content: _Content6
    };
  }

  if (type === 'number' || type === 'range') {
    var {
      name: _name7,
      value: _value7,
      max,
      min,
      step,
      plaintext: _plaintext3,
      readOnly: _readOnly2,
      disabled: _disabled7,
      size: _size5,
      placeholder: _placeholder3,
      label: _label7,
      hiddenLabel: _hiddenLabel7,
      onChange: _onChange7,
      handleChange: _handleChange7
    } = props;

    var _Label6;

    if (!_hiddenLabel7) {
      _Label6 = (0, _FieldCommon.getSectionLabel)(props);
    } else {
      propsControl['aria-label'] = _label7;
    }

    if (type === 'number') {
      propsControl.placeholder = _placeholder3;
      propsControl.size = _size5;
      propsControl.plaintext = _plaintext3;
      propsControl.readOnly = _readOnly2;
    }

    propsControl.disabled = _disabled7;
    propsControl.max = max;
    propsControl.min = min;
    propsControl.step = step;
    propsControl.value = getNumber(_value7);

    propsControl.onChange = e => {
      var value = getNumber(e.target.value);

      if (_onChange7) {
        _onChange7(value);
      }

      _handleChange7(_name7, value);
    };

    var _Content7 = /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactBootstrap.Form.Control, propsControl), SectionHelp, SectionFeedback);

    return {
      Content: _Content7,
      Label: _Label6
    };
  }

  if (type === 'textarea') {
    var {
      name: _name8,
      value: _value8,
      plaintext: _plaintext4,
      readOnly: _readOnly3,
      disabled: _disabled8,
      size: _size6,
      placeholder: _placeholder4,
      rows,
      label: _label8,
      hiddenLabel: _hiddenLabel8,
      onChange: _onChange8,
      handleChange: _handleChange8
    } = props;

    var _Label7;

    if (!_hiddenLabel8) {
      _Label7 = (0, _FieldCommon.getSectionLabel)(props);
    } else {
      propsControl['aria-label'] = _label8;
    }

    propsControl.as = type;
    propsControl.rows = rows;
    propsControl.placeholder = _placeholder4;
    propsControl.size = _size6;
    propsControl.plaintext = _plaintext4;
    propsControl.readOnly = _readOnly3;
    propsControl.disabled = _disabled8;
    propsControl.value = _value8;

    propsControl.onChange = e => {
      var value = e.target.value;

      if (_onChange8) {
        _onChange8(value);
      }

      _handleChange8(_name8, value);
    };

    var _Content8 = /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactBootstrap.Form.Control, propsControl), SectionHelp, SectionFeedback);

    return {
      Content: _Content8,
      Label: _Label7
    };
  }

  var {
    name,
    value,
    plaintext,
    readOnly,
    disabled,
    size,
    placeholder,
    label,
    hiddenLabel,
    onChange,
    handleChange
  } = props;
  var Label;

  if (!hiddenLabel) {
    Label = (0, _FieldCommon.getSectionLabel)(props);
  } else {
    propsControl['aria-label'] = label;
  }

  propsControl.placeholder = placeholder;
  propsControl.size = size;
  propsControl.plaintext = plaintext;
  propsControl.readOnly = readOnly;
  propsControl.disabled = disabled;
  propsControl.value = value;

  propsControl.onChange = e => {
    var value = e.target.value;

    if (onChange) {
      onChange(value);
    }

    handleChange(name, value);
  };

  var Content = /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactBootstrap.Form.Control, propsControl), SectionHelp, SectionFeedback);

  return {
    Content,
    Label
  };
};

var createControlHidden = (isValid, isInvalid) => /*#__PURE__*/_react.default.createElement(_reactBootstrap.Form.Control, {
  type: 'hidden',
  isValid,
  isInvalid
});