"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RBFieldArray = void 0;

var _react = _interopRequireDefault(require("react"));

var _formik = require("formik");

var _reactBootstrap = require("react-bootstrap");

var _FieldCommon = require("./FieldCommon");

var _Field = require("./Field");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var RBFieldArray = props => {
  var {
    name
  } = props,
      rest = _objectWithoutProperties(props, ["name"]); // Make sure to remove 'name' form the rest.


  var {
    values,
    errors,
    didSubmbit,
    handleChange,
    initialValues,
    addButton,
    noRowsMessage,
    children,
    as,
    label
  } = rest;

  var Component = /*#__PURE__*/_react.default.createElement(_formik.FieldArray, {
    name,
    render: (_ref) => {
      var {
        push,
        remove
      } = _ref;

      var addFunction = () => push(initialValues);

      var Add = addButton === undefined || addButton == true ? /*#__PURE__*/_react.default.createElement(_reactBootstrap.Button, {
        className: "mb-3",
        variant: "primary",
        type: "button",
        onClick: addFunction
      }, "Add") : !addButton ? null : addButton(addFunction);
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, values && values.length > 0 ? values.map((_, indexValue) => /*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
        key: indexValue
      }, (0, _FieldCommon.RBFormObjectRecursiveAssignProps)(children, child => {
        var {
          type,
          props
        } = child;
        var {
          type: typeValue,
          nameValue,
          customInput
        } = props;
        var typeComponent = customInput ? 'custom' : type;

        switch (typeComponent) {
          case _Field.RBField:
            return (0, _FieldCommon.RBFieldAssignProps)({
              name: nameValue,
              type: typeValue,
              values,
              errors,
              didSubmbit,
              handleChange,
              nameArray: name,
              indexValue
            }, true);

          case RBFieldArray:
            return (0, _FieldCommon.RBArrayAssignProps)({
              name: nameValue,
              values,
              errors,
              didSubmbit,
              handleChange,
              initialValues,
              nameArray: name,
              indexValue
            }, true);

          case 'custom':
            return (0, _FieldCommon.RBCustomAssignProps)({
              name: nameValue,
              type: typeValue,
              values,
              errors,
              didSubmbit,
              handleChange,
              nameArray: name,
              indexValue
            }, true);

          default:
            {
              if (props['array-remove']) {
                return {
                  ['array-remove']: 'true',
                  onClick: () => {
                    remove(indexValue);
                  }
                };
              }

              return;
            }
        }
      }))) : noRowsMessage, Add);
    }
  });

  return (0, _FieldCommon.getLayout)({
    as
  }, label && (0, _FieldCommon.getSectionLabel)(rest), Component, rest);
};

exports.RBFieldArray = RBFieldArray;