"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RBFieldGroup = void 0;

var _FieldCommon = require("./FieldCommon");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var RBFieldGroup = props => {
  var {
    id,
    label,
    hiddenLabel,
    as,
    children
  } = props;
  var propsGroup = {
    id,
    role: 'group',
    as
  };

  var propsLabel = _objectSpread(_objectSpread({}, props), {}, {
    name: id,
    className: 'rbf-group'
  });

  var Label;

  if (!hiddenLabel) {
    Label = (0, _FieldCommon.getSectionLabel)(propsLabel);
    propsGroup['aria-labelledby'] = (0, _FieldCommon.getIdLabel)(id);
  } else {
    propsGroup['aria-label'] = label;
  }

  return (0, _FieldCommon.getLayout)(propsGroup, Label, children, props);
};

exports.RBFieldGroup = RBFieldGroup;